// Generated by CoffeeScript 1.9.0
var cjdn2CR, cjdn2gd, lc2CJDN;

lc2CJDN = function() {
  return $("input.idiom\\:longcount").each(function() {
    var baktun, baktunDays, baktunValue, calcFurther, cjdn, katun, katunDays, katunValue, kin, kinDays, kinValue, longCountisValid, longcount, longcountValues, refId, tun, tunDays, tunValue, winal, winalDays, winalValue;
    refId = $(this).parent().parent().parent().parent().attr('id');
    longcount = $(this).val();
    longcountValues = longcount.split(".");
    calcFurther = true;
    if (longcountValues.length === 1 || longcountValues.length > 5) {
      calcFurther = false;
    }
    if (longcountValues.length < 5 && longcountValues.length > 1) {
      alert("Value Missing. Check Longcount. Long Counts should have at least 5 values.");
    } else {
      longcountValues = longcount.split(".");
      baktun = longcountValues[0];
      katun = longcountValues[1];
      tun = longcountValues[2];
      winal = longcountValues[3];
      kin = longcountValues[4];
      longCountisValid = validateLongCount(longcount);
    }
    baktunDays = 144000;
    katunDays = 7200;
    tunDays = 360;
    winalDays = 20;
    kinDays = 1;
    baktunValue = baktun * baktunDays;
    katunValue = katun * katunDays;
    tunValue = tun * tunDays;
    winalValue = winal * winalDays;
    kinValue = kin * kinDays;
    cjdn = baktunValue + katunValue + tunValue + winalValue + kinValue;
    if (calcFurther === true && longCountisValid === true) {
      cjdn2gd(cjdn, refId);
      return cjdn2CR(cjdn, refId, baktun, katun, tun, winal, kin);
    }
  });
};

cjdn2gd = function(cjdn, refId) {
  var bce, c0, cjdn2, correlationConstAtronomic, day, gregdate, k1, k2, k3, month, x1, x2, x3, year;
  cjdn2 = cjdn + 584283;
  correlationConstAtronomic = 584283;
  bce = false;
  k3 = 4 * (cjdn + correlationConstAtronomic - 1721120) + 3;
  x3 = parseInt(k3 / 146097, 10);
  if (x3 < 0) {
    x3 = x3 - 1;
  }
  if (k3 < 0) {
    k2 = 100 * parseInt(((k3 % 146097) + 146097) % 146097 / 4, 10);
  } else {
    k2 = 100 * parseInt((k3 % 146097) / 4, 10) + 99;
  }
  x2 = parseInt(k2 / 36525, 10);
  if (k2 < 0) {
    k1 = 5 * parseInt(((k2 % 36525) + 36525) % 36525 / 100, 10) + 2;
  } else {
    k1 = 5 * parseInt((k2 % 36525) / 100, 10) + 2;
  }
  x1 = parseInt(k1 / 153, 10);
  c0 = parseInt((x1 + 2) / 12, 10);
  year = 100 * x3 + x2 + c0;
  month = x1 - 12 * c0 + 3;
  if (k1 < 0) {
    day = parseInt(((k1 % 153) + 153) % 153 / 5, 10) + 1;
  } else {
    day = parseInt((k1 % 153) / 5, 10) + 1;
  }
  if (year < 0) {
    year = --year * -1;
    bce = true;
  }
  if (bce) {
    ++day;
  }
  if (month < 10) {
    month = "0" + month;
  }
  if (day < 10) {
    day = "0" + day;
  }
  if (year < 1000 && year > 100) {
    year = "0" + year;
  }
  gregdate = year + "-" + month + "-" + day;
  $("div#" + refId + " input#idiom\\:gregorianDate").val(gregdate);
  if (bce) {
    return $("div#" + refId + " button#idiom\\:calendarEra  span[class=\"value\"]").text("BCE");
  } else {
    return $("div#" + refId + " button#idiom\\:calendarEra  span[class=\"value\"]").text("CE");
  }
};

cjdn2CR = function(cjdn, refId, baktun, katun, tun, winal, kin) {
  var baktunMultiplier, haab, haabDay, haabMonth, haabPreValue, haabValue, katunMultiplier, kinMultiplier, newCJDN, tunMultiplier, tzolkin, tzolkinDay, tzolkinIndex, tzolkinMonth, winalMultiplier;
  tzolkin = ["Ajaw", "Imix", "Ik", "Ak'bal", "K'an", "Chikchan", "Kimí", "Manik'", "Lamat", "Muluk", "Ok", "Chuwen", "Eb", "Ben", "Ix", "Men", "Kib", "Kaban", "Etz'nab", "Kawak"];
  if ((4 + cjdn) < 0) {
    newCJDN = 4 + cjdn;
    tzolkinDay = ((newCJDN % 13) + 13) % 13;
  } else {
    tzolkinDay = (4 + cjdn) % 13;
    if (tzolkinDay === 0) {
      tzolkinDay = tzolkinDay + 13;
    }
    if (cjdn < 0) {
      tzolkinIndex = ((cjdn % 20) + 20) % 20;
      tzolkinMonth = tzolkin[tzolkinIndex];
    } else {
      tzolkinMonth = tzolkin[cjdn % 20];
    }
  }
  haab = ["Pop", "Wo", "Sip", "Sotz'", "Tzek", "Xul", "Yaxk'in", "Mol", "Ch'en", "Yax", "Sak", "Keh", "Mac", "K'ank'in", "Muwan", "Pax", "K'ayab", "Kumk'u", "Wayeb"];
  kinMultiplier = 1;
  winalMultiplier = 20;
  tunMultiplier = -5;
  katunMultiplier = -100;
  baktunMultiplier = -175;
  haabPreValue = -17 + ((kin * kinMultiplier) + (winal * winalMultiplier) + (tun * tunMultiplier) + (katun * katunMultiplier) + (baktun * baktunMultiplier));
  if (haabPreValue < 0) {
    haabValue = ((haabPreValue % 365) + 365) % 365;
  } else {
    haabValue = haabPreValue % 365;
  }
  haabMonth = haab[parseInt(haabValue / 20, 10)];
  haabDay = haabValue % 20;
  $("div#" + refId + " input#idiom\\:tzolkinInput").val(tzolkinDay);
  $("div#" + refId + " input#idiom\\:haabInput").val(haabDay);
  $("div#" + refId + " button#idiom\\:tzolkinUnit span[class=\"value\"]").text(tzolkinMonth);
  return $("div#" + refId + " button#idiom\\:haabUnit span[class=\"value\"]").text(haabMonth);
};
